<template lang="pug">
tr(v-show='enabled || showDisabled' :class='{ "text-muted": !enabled }')
  td.b-clickable(v-if="inEdit")
    input(ref='selected' type='checkbox' v-model='selected')
  td.py-0.text-center.text-nowrap(v-else @click='focusChannel')
    i.fa.fa-caret-right.b-clickable
  td.py-0.text-center.text-nowrap
    BaseToggle(ref='enabled' :value='enabled' :inEdit='inEdit'
      @edit='pushValue("enabled", $event)') {{ enabled }}
  td.py-0.text-center(key='location') {{ daq.name.replace('ntofdaq-', '') }}:{{ card.index }}:{{ channel }}
  td.py-0.text-center(v-show='!inEdit') {{ detectorType }} / {{ detectorId }}
  td.py-0.text-center(v-show='inEdit')
    BaseInput.mw-5(ref='detectorType' :value="detectorType" :inEdit='inEdit' maxlength="4" :noEditIcon='true'
      @edit='pushValue("detectorType", $event)')
  td.py-0.text-center(v-show='inEdit')
    BaseInput.mw-5(ref='detectorId' :value="detectorId" :inEdit='inEdit' :noEditIcon='true'
        @edit='pushValue("detectorId", $event)')
      template(#default='input')
        .input-group.col-12
          .input-group-prepend(v-if='inEdit && selected' @click="$emit('gen-detector-id', channelId)")
            label.input-group-text.b-clickable.p-1(title='Generate detectorIds for selected items') #[i.fa.fa-sync.small]
          input.text-right.text-sm-center(v-if='inEdit' type='number' min='0' step='1'
            :value='input.editValue' @input='$refs.detectorId.editValue = $event.target.value'
            @wheel='$event.target.blur()')
          input.text-right.text-sm-center(v-else readonly='1' :value='input.value')
  td.py-0.text-center(v-show='!inEdit && mediaXL') {{ card.type }}
  td.py-0.text-center(v-show='!inEdit && mediaXL') {{ card.serialNumber }}
  td.py-0.text-center
    BaseSelect.mw-5(v-if='channel === 0' ref='sampleRate' :value="sampleRate" :inEdit='inEdit'
      :options="SampleRateValues" :noEditIcon='true'
      @edit='updateEditSampleSize(); pushCardValue("sampleRate", $event)')
    span(v-else) -
  td.py-0.text-center
    BaseInputReadonly.mw-5(v-if='channel === 0' ref="sampleSize"
      :inEdit='inEdit' :value="sampleSize" :noEditIcon='true'
      type="number" :max="maxSampleSize" :min="minSampleSize"
      @wheel.native='$event.target.blur()'
      @edit='$refs.sampleSize.checkValidity(); pushCardValue("sampleSize", $event, false)' )
    span(v-else) -
  td.py-0.text-center
    BaseInput.mw-5(v-if='channel === 0' ref="timeWindow"
      type='number' step='0.001' :max="maxEditTimeWindow" min='0' :noEditIcon='true'
      :inEdit='inEdit' :value="timeWindow"
      @wheel.native='$event.target.blur()'
      @edit='updateEditSampleSize(); emitPushValue("timeWindow", $event)')
    span(v-else) -
  td.py-0.text-center(v-show='mediaXL')
    BaseInput.mw-5(v-if='channel === 0' ref='delay'
      type='number' :noEditIcon='true' :value="delay" :inEdit='inEdit'
      @wheel.native='$event.target.blur()'
      @edit='pushCardValue("delay", $event)')
    span(v-else) -
  td.py-0.text-center
    BaseSelect.mw-5(ref='fullScale'
        :value="fullScale" :inEdit='inEdit' :noEditIcon='true'
        @edit='updateEditOffset(); pushValue("fullScale", $event)')
      template(#options='')
        option(v-for='value in FullScaleValues') {{ value }}
  td.py-0.text-center(v-show='inEdit')
    BaseInputReadonly.mw-5(ref="offset"
        :value="offset" type="number" :noEditIcon='true'
        :max="OffsetLimits" :min="-OffsetLimits" :inEdit="inEdit"
        @edit='checkOffsetWarning(); pushValue("offset", $event, false)')
  td.py-0.text-center
    BaseInput.mw-5(ref="lowerLimit" type="number"
        :value="lowerLimit" :inEdit='inEdit' :noEditIcon='true'
        @wheel.native='$event.target.blur()'
        @edit='updateEditOffset(); emitPushValue("lowerLimit", $event)')
  td.py-0.text-center(v-show='mediaXL')
    BaseSelect.mw-3(ref='impedance' :value="impedance" :inEdit='inEdit'
        :options="ImpedanceValues" :noEditIcon='true'
        @edit='pushValue("impedance", $event)')
  td.py-0.text-center
    BaseToggle.p-0(ref='isZSP' :value='isZSP' @edit='onZSPEdit' :inEdit='inEdit')
  td.py-0.text-center
    BaseSelect.mw-3(ref='thresholdSign' :value="thresholdSign" :inEdit='inEdit' :noEditIcon='true'
        v-show='!(inEdit && !isZSPEdit)'
        :options='[ { value: 1, text: "+" }, { value: 0, text: "-" } ]'
        @edit='pushValue("thresholdSign", $event)')
    BaseInput.mw-3(v-if='inEdit && !isZSPEdit'
        :value='thresholdSign ? "+" : "-"' :inEdit='inEdit' :noEditIcon='true' :disabled='true')
  td.py-0.text-center
    BaseInput.mw-5(ref='threshold' :value="threshold" :inEdit='inEdit' :noEditIcon='true'
        type='number'  step='any'
        @wheel.native='$event.target.blur()'
        @edit='pushValue("threshold", $event)' :disabled='inEdit && !isZSPEdit')
  td.py-0.text-center(v-show='mediaXL')
    BaseInput.mw-5(ref='zsStart' type='number' :value="zsStart" :inEdit='inEdit' :noEditIcon='true'
        @wheel.native='$event.target.blur()'
        @edit='pushValue("zsStart", $event)' :disabled='inEdit && !isZSPEdit')
  td.py-0.text-center.text-nowrap(v-show='!inEdit && mediaXL') {{ preSamples }} / {{ postSamples }}
  td.py-0.text-center(v-show='inEdit && mediaXL')
    BaseInput.mw-5(ref='preSamples' type='number' :value="preSamples" :inEdit="true" :noEditIcon='true'
        @wheel.native='$event.target.blur()'
        @edit='pushValue("preSamples", $event)' :disabled='inEdit && !isZSPEdit')
  td.py-0.text-center(v-show='inEdit && mediaXL')
    BaseInput.mw-5(ref='postSamples' type='number' :value="postSamples" :inEdit="true" :noEditIcon='true'
        @wheel.native='$event.target.blur()'
        @edit='pushValue("postSamples", $event)' :disabled='inEdit && !isZSPEdit')
</template>
<script>

export { default } from './DaqTableChannel.vue.js';

</script>
<style lang='scss'>
.x-daqtable td {
  .b-input {
    padding: 0.125rem !important;
    input {
      // forced background even on table-hover
      background-color: white!important;
    }
    input.b-in-edit[readonly] {
      // forced background even on table-hover
      background-color: #e9ecef!important;
    }
  }
  .mw-3 {
    min-width: 3rem;
  }
  .mw-5 {
    min-width: 5rem;
  }
}
</style>
